-- button.e

include rfont.e   -- jiri babor

function cntblk(sequence s, integer max)
    if max <= length(s) then
        return 0
    end if      
    return floor((max-length(s))/2)
end function

global constant LABEL_BUTTON = 1, TOGGLE_BUTTON = 2

global
procedure label(integer x, integer y, sequence s, integer color)
    set_foreground(color)
    setx(x) sety(y)
    write(s)
end procedure                                    

global
function labelbutton(integer x, integer y, sequence s, integer color,
                     integer max)
    sequence blk
    integer x1,y1,xlen,ylen,slen,margin
    margin = 5
    blk = repeat(' ',cntblk(s,max))          
    slen = max*8
    x1 = x-margin
    y1 = y-margin
    xlen = slen+margin+3
    ylen = 22
    polygon(0,0,{{x1,y1},{x1+xlen,y1},{x1+xlen,y1+ylen},{x1,y1+ylen}})
    label(x,y,blk&s&blk,color)
    return {s,{x,x+xlen,y,y+ylen}}
end function



global
function togglebutton(integer x, integer y, sequence s, integer color,
                    integer flag, integer max)
    sequence blk
    integer x1,y1,xlen,ylen,slen,margin
    margin = 5  
    if length(s) != 2 then
       return {} 
    end if
    slen = max*8
    if flag then
        s = s[1]
    else
        s = s[2]
    end if
    blk = repeat(' ',cntblk(s,max))          
    x1 = x-margin
    y1 = y-margin
    xlen = slen+margin+3
    ylen = 22
    polygon(0,1,{{x1,y1},{x1+xlen,y1},{x1+xlen,y1+ylen},{x1,y1+ylen}})
    label(x,y,blk&s&blk,color)
    return {s,{x1,x1+xlen,y1,y1+ylen},max}
end function


global function createbuttons(integer x, integer y, sequence list, 
                integer max)
    sequence s
    integer yy
    s = {}
    for i=1 to length(list) do
        if list[i][1] = LABEL_BUTTON then
            yy = y + (i-1) * 22
            s = append(s,labelbutton(x,yy,list[i][2],0,max))
        elsif list[i][1] = TOGGLE_BUTTON then
            yy = y + (i-1) * 22
            s = append(s,togglebutton(x,yy,list[i][2],0,1,max))
        end if
    end for
    return s
end function

global
function selectbutton(integer ms, integer my, sequence list)
    for i=1 to length(list) do
        if ms>list[i][2][1] and ms<list[i][2][2] and 
           my>list[i][2][3] and my<list[i][2][4]  then
           return list[i][1] 
        end if
    end for                 
    return {}
end function


