-- defs.e

without warning

global constant TRUE       =            1
global constant FALSE      =            0

global constant MOVE_STACK =            4096
global constant HIST_STACK =            64

global constant LIGHT      =            0
global constant DARK       =            1

global constant LIGHT_0    =            1 
global constant DARK_1     =            2

global constant PAWN       =            0
global constant KNIGHT     =            1
global constant BISHOP     =            2
global constant ROOK       =            3
global constant QUEEN      =            4
global constant KING       =            5 

global constant EMPTY      =            6

global constant FILE_ = {
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8,
        1, 2, 3, 4, 5, 6, 7, 8
}

global constant RANK_ = {
        1, 1, 1, 1, 1, 1, 1, 1,
        2, 2, 2, 2, 2, 2, 2, 2,
        3, 3, 3, 3, 3, 3, 3, 3,
        4, 4, 4, 4, 4, 4, 4, 4,
        5, 5, 5, 5, 5, 5, 5, 5,
        6, 6, 6, 6, 6, 6, 6, 6,
        7, 7, 7, 7, 7, 7, 7, 7,
        8, 8, 8, 8, 8, 8, 8, 8
}


---/* This is the basic description of a move. promote is what
--   piece to promote the pawn to, if the move is a pawn
--   promotion. bits is a bitfield that describes the move,
--   with the following bits:
--
--   1        capture
--   2        castle
--   4        en passant capture
--   8        pushing a pawn 2 squares
--   16       pawn move
--   32       promote
-- */

global constant FROM=1,TO=2,PROMOTE=3,BITS=4
global constant MOVE_REC = repeat(0,4)

global constant MOVE_=1,SCORE = 2
global constant GEN_REC = {MOVE_REC,0}

--/* an element of the history stack, with the information
--   necessary to take a move back. */

global constant CAP=2,CAS=3,EP=4,FIFTY=5
global constant HIST_REC = {MOVE_REC,0,0,0,0}

global integer BOOKON, DEPTHMAX


