-- main.ex
--  
-- Tom Kerrigan's Simple Chess Program (TSCP)
-- version 1.3, 11/11/98
-- Translated from C to EUPHORIA by Normand M. Blais
-- Feb-April 1999

without type_check
without warning

include get.e

include defs.e
include data.e
include board.e
include screen.e
include search.e

integer from_sq, to_sq

procedure build_move()
  -- construct the player's move      
    if gameover then
        return 
    end if              
    if from_sq = 0 then
        from_sq = bd_square 
        bd_square = 0         
        mouse_pointer(0)
        select_square(from_sq,WHITE) 
        mouse_pointer(1)
    elsif from_sq and from_sq = to_sq then
        if rotate then
            mouse_pointer(0)
            if Color[65-from_sq] = 0 then
                select_square(from_sq,WCOLOR)
            elsif Color[65-from_sq] = 1 then
                select_square(from_sq,0)
            end if
            mouse_pointer(1)
        else
            mouse_pointer(0)
            if Color[from_sq] = 0 then
                select_square(from_sq,WCOLOR)
            elsif Color[from_sq] = 1 then
                select_square(from_sq,0)
            end if
            mouse_pointer(1)
        end if
        from_sq = 0 to_sq = 0 bd_square = 0
    elsif from_sq and to_sq = 0 then   
        to_sq = bd_square 
        bd_square = 0
        if rotate then
            mouse_pointer(0)
            if Color[65-from_sq] = 0 then
                select_square(from_sq,WCOLOR)
            elsif Color[65-from_sq] = 1 then
                select_square(from_sq,0)
            end if
            mouse_pointer(1)
        else
            mouse_pointer(0)
            if Color[from_sq] = 0 then
                select_square(from_sq,WCOLOR)
            elsif Color[from_sq] = 1 then
                select_square(from_sq,0)
            end if
            mouse_pointer(1)
        end if
    end if
end procedure          


integer hash_value, hash_first,hash_temp

--/* main is basically an infinite loop that either calls
--   think() when it's the computer's turn to move or prompts
--   the user for a command (and deciphers it). */
procedure main() 
    sequence eventmessage
    integer junk
    integer k,computer_side
    integer found

    init() 

    gen() 

    computer_side=EMPTY 

    from_sq=0 to_sq=0

--    puts(1,"Loading opening database...\n")
--    load_opening_book()

    start_screen_application()

    logo()

    status_bar()

    update_status_bar(1,EMPTY,EMPTY) -- COMPUTER
    update_status_bar(2,1,1) -- LEVEL
    update_status_bar(3,0,0) -- BOOK (disabled)
    update_status_bar(4,0,0) -- TURN
    

    k = 0

--    hash_first = hash_init()
--    hash_value = hash_first
    BOOKON = 0
    DEPTHMAX = 1
    counter = 1
    mouse_events(LEFT_DOWN)
    while 1 do
        if computer_side = side and not gameover then  --/* computer's turn */
            think()   
--            hash_value = hash(pv[1][1],hash_value)
            last_move_side = side
            junk = makemove(pv[1][1]) 
            capture_piece = hist_dat[1][CAP]
            ep_square = hist_dat[1][EP]
            move_list = append(move_list,hist_dat[1])
            counter += 1
            ply = 1
            gen()
            mouse_pointer(0)
            screen_move(pv[1][1])
            update_status_bar(4,last_move_side,side) -- TURN
            mouse_pointer(1)
        else
            mouse_pointer(1)
            eventmessage = geteventmessage()
            mouse_pointer(0)
            if eventmessage[EVMOUSE] = QUIT then
                exit
            elsif eventmessage[EVMOUSE] = COMPUTER then
                if computer_side = EMPTY then
                    computer_side=side
                    update_status_bar(1,EMPTY,1) -- COMPUTER
                else    
                    computer_side=EMPTY 
                    update_status_bar(1,1,EMPTY) -- COMPUTER
                end if
            elsif eventmessage[EVMOUSE] = PLAY then
                update_status_bar(1,computer_side,1) -- COMPUTER
                computer_side=side
            elsif eventmessage[EVMOUSE] = LV then
                junk = DEPTHMAX
                DEPTHMAX += 1
                if DEPTHMAX > 4 then
                    DEPTHMAX = 1
                end if
                update_status_bar(2,junk,DEPTHMAX) -- LEVEL
--            elsif eventmessage[EVMOUSE] = BOOK then
--                junk = BOOKON
--                BOOKON = xor_bits(BOOKON,1)
--                update_status_bar(3,junk,BOOKON) -- BOOK
            elsif eventmessage[EVMOUSE] = HINT then
                hint()
            elsif eventmessage[EVMOUSE] = NEW then
                computer_side=EMPTY 
                polygon(CYAN,1,{{50,370},{639,370},{639,479},{50,479}})
                init()
                ply = 1
                gen() 
--                hash_value = hash_first
                counter = 1
                mouse_pointer(0)
                draw_screen_position()      
                update_status_bar(4,xor_bits(side,1),0) -- TURN
                update_status_bar(1,1,EMPTY) -- COMPUTER
                mouse_pointer(1)
            elsif eventmessage[EVMOUSE] = ROTATE then
                rotate = xor_bits(rotate,1)
                rotate_coord()
                mouse_pointer(0)
                draw_screen_position()
                mouse_pointer(1)
            elsif eventmessage[EVMOUSE] = BACK and counter > 1 then
                computer_side=EMPTY 
                ply += 1
                hist_dat[1] = move_list[length(move_list)]
                capture_piece = hist_dat[1][CAP]
                takeback()
                back = 1
                mouse_pointer(0)
                screen_move(move_list[length(move_list)][MOVE_])
                update_status_bar(1,1,EMPTY) -- COMPUTER
                mouse_pointer(1)
--                hash_value = hash(move_list[length(move_list)][MOVE_],hash_value)
                last_move_side = xor_bits(last_move_side,1) 
                move_list = move_list[1..length(move_list)-1]
                counter -= 1
                ply = 1
                gen()   
                back = 0
                ep_square = 0
            elsif eventmessage[EVKEYBOARD] = ESC then
                exit
            elsif eventmessage[EVMOVE] = MOVE  and not gameover then
                build_move()
                if from_sq and to_sq and side != computer_side then
                    if rotate then
                        from_sq = 65 - from_sq
                        to_sq = 65 - to_sq
                    end if
                    found=FALSE                                 
                    k = 0
                    for i=1 to gen_end[ply] do 
                        if gen_dat[i][MOVE][FROM] = from_sq and 
                           gen_dat[i][MOVE][TO] = to_sq then
                            k = i
                            found=TRUE                           
                            --/* get the promotion piece right */
                            if and_bits(gen_dat[i][MOVE][BITS],32) then
                                mouse_pointer(1)
                                junk = promote(side)
                                mouse_pointer(0)
                                if junk = 2 then
                                    k+=1
                                elsif junk = 3 then
                                    k+=2
                                elsif junk = 4 then
                                    k+=3
                                end if
                            end if
                            exit
                        end if                         
                    end for
                    last_move_side = side
--                    if found then
--                        hash_temp = hash(gen_dat[k][MOVE_],hash_value)
--                    end if
                    if not found or not makemove(gen_dat[k][MOVE_]) then
                        -- Illegal move
                    else
                        mouse_pointer(0)
                        screen_move(gen_dat[k][MOVE_])
                        update_status_bar(4,last_move_side,side) -- TURN
                        mouse_pointer(1)
                        capture_piece = hist_dat[1][CAP]
                        ep_square = hist_dat[1][EP]
                        move_list = append(move_list,hist_dat[1])
                        counter += 1
--                        hash_value = hash_temp
                        ply = 1
                        gen()  
                    end if
                    from_sq = 0 to_sq = 0
                end if
            end if
        end if
    end while               
   terminate_screen_application()
end procedure

main()


